/* Frequent Flier
 *
 * For every window of m months, keep track of how many flights are paid for.
 * If not enough are paid for, pay for the latest flights in the window. Use a
 * data structure (heap or stack) to keep track of the latest flights you can
 * pay for.
 */
#include <algorithm>
#include <cassert>
#include <cstdint>
#include <iostream>
#include <numeric>
#include <vector>

int main() {
    int32_t n, m;
    int64_t k;
    std::cin >> n >> m >> k;

    std::vector<int64_t> f(n);
    for (auto& x : f) {
        std::cin >> x;
    }

    n += m;
    for (auto i = 0; i < m; ++i) {
        f.push_back(0);
    }

    std::vector<int64_t> paid(n, 0);
    int64_t curPaid = 0;

    std::vector<int64_t> stk;
    for (auto i = 0, l = 0; i < n; ++i) {
        while (l + m <= i) {
            curPaid -= paid[l];
            ++l;
        }

        if (f[i]) {
            stk.push_back(i);
        }
        while (curPaid < k && !stk.empty()) {
            auto j = stk.back();
            stk.pop_back();

            if (j < l) continue;

            int64_t toBuy = std::min(f[j] - paid[j], k - curPaid);
            assert(toBuy > 0);
            paid[j] += toBuy;
            curPaid += toBuy;
            if (paid[j] < f[j]) {
                stk.push_back(j);
            }
        }
    }

    int64_t ans = 0;
    for (auto x : paid)
        ans += x;

    std::cout << ans << '\n';

    return 0;
}
